-- Buttons

local A = BT_JUMP
local B = BT_CUSTOM2
local X = BT_USE|BT_SPIN if srb2p X = BT_CUSTOM3 end
local Y = BT_CUSTOM3 if srb2p Y = 0 end
local LB = BT_WEAPONPREV
local RB = BT_WEAPONNEXT
local LT = BT_CUSTOM1
local RT = BT_ATTACK|BT_FIRENORMAL

local function TAPPING(player)
	for player in players.iterate
		if player.realmo.skin == "ace" or player.wizlite
			if not (player.cmd.buttons & A)
				player.atapready = true
				player.atap = false
			elseif player.atapready then
				player.atap = true
				player.atapready = false
			else
				player.atap = false
			end
			
			if not (player.cmd.buttons & B)
				player.btapready = true
				player.btap = false
			elseif player.btapready then
				player.btap = true
				player.btapready = false
			else
				player.btap = false
			end
			
			if not (player.cmd.buttons & X)
				player.xtapready = true
				player.xtap = false
			elseif player.xtapready then
				player.xtap = true
				player.xtapready = false
			else
				player.xtap = false
			end
			
			if not (player.cmd.buttons & Y)
				player.ytapready = true
				player.ytap = false
			elseif player.ytapready then
				player.ytap = true
				player.ytapready = false
			else
				player.ytap = false
			end
			
			if not (player.cmd.buttons & LB)
				player.lbtapready = true
				player.lbtap = false
			elseif player.lbtapready then
				player.lbtap = true
				player.lbtapready = false
			else
				player.lbtap = false
			end
			
			if not (player.cmd.buttons & RB)
				player.rbtapready = true
				player.rbtap = false
			elseif player.rbtapready then
				player.rbtap = true
				player.rbtapready = false
			else
				player.rbtap = false
			end
			
			if not (player.cmd.buttons & LT)
				player.lttapready = true
				player.lttap = false
			elseif player.lttapready then
				player.lttap = true
				player.lttapready = false
			else
				player.lttap = false
			end
			
			if not (player.cmd.buttons & RT)
				player.rttapready = true
				player.rttap = false
			elseif player.rttapready then
				player.rttap = true
				player.rttapready = false
			else
				player.rttap = false
			end
		end
	end
end

addHook("ThinkFrame", TAPPING)

-- Custom Functions

local function P_IsObjectInFan(mo)
	if mo.subsector and mo.subsector.sector
		local InFan = false
		if mo.subsector.sector.special == 20480
			InFan = true
		elseif not InFan
			for fof in mo.subsector.sector.ffloors()
				if fof.sector and fof.sector.special == 20480
				and ((mo.z + mo.height > fof.bottomheight) and (mo.z < fof.topheight))
					InFan = true
				end
			end
		end
		
		return InFan
	end
end

-- Player Spawn

addHook("PlayerSpawn", function(player)
	player.wiz = nil
end)

-- TODO: make the tornado

/*local function AceTornado(player)
	if player.mo.valid and player.mo.skin == "ace"
		
	end
end*/

-- Elements Jump Abilities

---- Earth Platform/Boulder Jump
------ TODO: make a platform grow to the height of the player when close to a surface with an earth type texture

/*local Ground =
{
	
}*/

local function EarthPlatform(player) --(WIP)
	if player.mo.valid and player.mo.skin == "ace"
	and player.wiz.jumpabilitytime == 35
		//if 
			/*local Platform = P_SpawnMobj(
			player.mo.x + FixedMul(player.rmomx, player.mo.radius),
			player.mo.y + FixedMul(player.rmomy, player.mo.radius),
			player.mo.floorz,//player.mo.z + player.mo.momz - player.height,
			MT_ACEEARTHPLAT)
			
			Platform.tracer = player.mo
			
			if Platform.ceilingz < Platform.tracer.floorz// + mobj.tracer.player.height//+ mobj.tracer.momz - mobj.tracer.player.height
				P_SetObjectMomZ(Platform, 10*FRACUNIT)
			elseif Platform.ceilingz >= Platform.tracer.floorz
				print("!")
			end*/
		//else
			P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
			player.wiz.jumpabilitytime = 10
			local Boulder = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_ACEBOULDER)
			Boulder.tracer = player.mo
			P_SetObjectMomZ(Boulder, -5*FRACUNIT)
			S_StartSound(player.mo, sfx_s3k49)
		//end
	end
end

---- Bubble Jump

local function BubbleJump(player)
	if player.mo.valid and player.mo.skin == "ace"
		if player.wiz.jumpabilitytime == 35
			player.mo.flags = $|MF_NOGRAVITY|MF_BOUNCE
			P_SetObjectMomZ(player.mo, FixedMul(2*FRACUNIT, player.mo.scale), true)
			player.wiz.bubble = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_ACEBUBBLE)
			player.wiz.bubble.target = player.mo
			S_StartSound(player.mo, sfx_splash)
		end
		
		if player.mo.subsector.sector.floorpic != "F_SKY1" and player.mo.subsector.sector.ceilingpic != "F_SKY1"
		and player.mo.subsector.sector.special != 6 and player.mo.subsector.sector.special != 7
			if ((player.mo.z - player.mo.height/4 + player.mo.momz <= player.mo.floorz and not (player.mo.eflags & MFE_VERTICALFLIP))
			or (player.mo.z + player.mo.height + player.mo.height/4 + player.mo.momz >= player.mo.ceilingz and (player.mo.eflags & MFE_VERTICALFLIP)))
			or ((player.mo.z + player.mo.height + player.mo.height/4 + player.mo.momz > player.mo.ceilingz and not (player.mo.eflags & MFE_VERTICALFLIP))
			or (player.mo.z - player.mo.height/4 + player.mo.momz < player.mo.floorz and (player.mo.eflags & MFE_VERTICALFLIP)))
				P_SetObjectMomZ(player.mo, -player.mo.momz/2)
			end
		end
		
		player.powers[pw_spacetime] = spacetimetics
	end
end

addHook("MobjThinker", function(shield)
	for player in players.iterate
		if shield and shield.valid
		and player.mo and shield.target == player.mo
			local ShieldZ
			if P_MobjFlip(shield.target) > 0
				ShieldZ = player.mo.z - 4*FRACUNIT
				
				shield.flags2 = $&~MF2_OBJECTFLIP
				shield.eflags = $&~MFE_VERTICALFLIP
			else
				ShieldZ = player.mo.z - 2*FRACUNIT
				
				shield.flags2 = $|MF2_OBJECTFLIP
				shield.eflags = $|MFE_VERTICALFLIP
			end
			
			P_MoveOrigin(shield, player.mo.x, player.mo.y, ShieldZ)
			
			shield.angle = player.drawangle
			shield.scale = player.shieldscale
		end
	end
end, MT_ACEBUBBLE)

---- Cloud Surf
---- TODO: make a actual cloud

local function CloudSurf(player)
	if player.mo.valid and player.mo.skin == "ace"
		if player.wiz.jumpabilitytime == 35
			S_StartSound(player.mo, sfx_s3kces)
		end
		
		player.acceleration = 20
		player.wiz.jumpabilityloop = true
		P_InstaThrust(player.mo, player.drawangle, FixedMul(10*FRACUNIT + (player.speed/2), player.mo.scale))
		P_SetObjectMomZ(player.mo, -3*FRACUNIT)
		local Thok = P_SpawnMobjFromMobj(player.mo, 0, 0, -player.height/2, MT_THOK)
		Thok.color = SKINCOLOR_CLOUDY
		Thok.scalespeed = 1*FRACUNIT/8
		Thok.destscale = 0
	end
end

---- Flame Dash

local function FlameDash(player)
	if player.mo.valid and player.mo.skin == "ace"
		if player.wiz.jumpabilitytime == 35
			player.acceleration = 20
			player.wiz.fireball = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_ACEFIREBALL)
			player.wiz.fireball.target = player.mo
			S_StartSound(player.mo, sfx_s1b3)
		end
		
		if player.wiz.jumpabilitytime >= 0
			player.charflags = $|SF_CANBUSTWALLS
			P_InstaThrust(player.mo, player.drawangle, FixedMul(20*FRACUNIT + (player.speed/2), player.mo.scale))
			P_SetObjectMomZ(player.mo, 0, false)
			local Thok = P_SpawnMobjFromMobj(player.wiz.fireball, 0, 0, 0, MT_THOK)
			Thok.color = SKINCOLOR_FLAME
			Thok.scalespeed = 1*FRACUNIT/8
			Thok.destscale = 0
		end
	end
end

addHook("MobjThinker", function(shield)
	for player in players.iterate
		if shield and shield.valid
		and player.mo and shield.target == player.mo
			local ShieldZ
			if P_MobjFlip(shield.target) > 0
				ShieldZ = player.mo.z - 4*FRACUNIT
				
				shield.flags2 = $&~MF2_OBJECTFLIP
				shield.eflags = $&~MFE_VERTICALFLIP
			else
				ShieldZ = player.mo.z - 2*FRACUNIT
				
				shield.flags2 = $|MF2_OBJECTFLIP
				shield.eflags = $|MFE_VERTICALFLIP
			end
			
			P_MoveOrigin(shield, player.mo.x, player.mo.y, ShieldZ)
			
			shield.angle = player.drawangle
			shield.scale = player.shieldscale
		end
	end
end, MT_ACEFIREBALL)

-- Activate Jump Ability

---- While Falling

addHook("JumpSpecial", function(player)
	if player.gotflag return end
	
	if player.mo.valid and player.mo.skin == "ace"
	and not (player.pflags & PF_JUMPED) and player.atap
		if not (gametyperules & GTR_RINGSLINGER) and not srb2p
			if not player.wiz.jumpability and player.wiz.jumpabilitydelay == 0
				player.wiz.jumpability = true
			end
		elseif ((gametyperules & GTR_RINGSLINGER) or srb2p) and not (player.pflags & PF_THOKKED)
			P_DoJump(player, true)
			local Thok = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
			Thok.color = player.acefairy.color
			player.pflags = $|PF_THOKKED
		end
	end
end)

---- While Jumping

addHook("AbilitySpecial", function(player)
	if player.gotflag return end
	
	if player.mo.valid and player.mo.skin == "ace"
		if not (gametyperules & GTR_RINGSLINGER) and not srb2p
			if not player.wiz.jumpability and player.wiz.jumpabilitydelay == 0
				player.wiz.jumpability = true
			end
		elseif ((gametyperules & GTR_RINGSLINGER) or srb2p) and not (player.pflags & PF_THOKKED)
			player.pflags = $&~PF_JUMPED
			P_DoJump(player, true)
			local Thok = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
			Thok.color = player.acefairy.color
			player.pflags = $|PF_THOKKED
		end
	end
end)

-- Vars Check

addHook("ThinkFrame", function()
	for player in players.iterate
		if not player.mo or player.mo.skin != "ace"
			if player.wiz
				player.wiz = nil
			end
		end
	end
end)

-- Cast and Shield Sprites

local CASTSPRITES = {
	[SPR2_STND] = SPR2_CAST,
	[SPR2_WAIT] = SPR2_CAST,
	[SPR2_EDGE] = SPR2_CAST,
	
	[SPR2_WALK] = SPR2_CWLK,
	[SPR2_RUN_] = SPR2_CRUN,
	[SPR2_SKID] = SPR2_CSKD,
	
	[SPR2_JUMP] = SPR2_CAIR,
	[SPR2_SPNG] = SPR2_CAIR,
	[SPR2_FALL] = SPR2_CAIR,
	
	[SPR2_SWIM] = SPR2_CSWM
}

local SHIELDSPRITES = {
	[SPR2_STND] = SPR2_SHLD,
	[SPR2_WAIT] = SPR2_SHLD,
	[SPR2_EDGE] = SPR2_SHLD,
	
	[SPR2_WALK] = SPR2_SWLK,
	[SPR2_RUN_] = SPR2_SRUN,
	[SPR2_SKID] = SPR2_SSKD,
	
	[SPR2_JUMP] = SPR2_SAIR,
	[SPR2_SPNG] = SPR2_SAIR,
	[SPR2_FALL] = SPR2_SAIR,
	
	[SPR2_SWIM] = SPR2_SSWM
}

-- Player Think

addHook("PlayerThink", function(player)
	if not player.wiz
		player.wiz =
		{element = 0,
		casting = false,
		castaim = 0,
		casttime = 100,
		castrecharge = false,
		castdelay = 0,
		shield = false,
		shieldtime = 100,
		shieldrecharge = false,
		shielddelay = 0,
		parry = false,
		parrytime = 2,
		twistability = false,
		twistabilitytime = 0,
		twistabilitydelay = 0,
		jumpability = false,
		jumpabilityloop = false,
		jumpabilitytime = 0,
		jumpabilitydelay = 0,
		jumpabilityblocked = false,
		crouching = false,
		forcecrouch = false,
		sliding = false,
		slidetime = 0,
		forceslide = false,
		sliping = false,
		fistslam = false,
		slamdelay = 0,
		slamtime = 0,
		sprinting = false,
		diving = false,
		wallslide = false,
		restart = false}
	end
	
	if player.mo and player.mo.skin == "ace"
	and player.powers[pw_carry] != CR_NIGHTSMODE
		local TwoD = twodlevel or (player.mo.flags2 & MF2_TWOD)
		
		-- Jump Ability
		
		if player.wiz.jumpability and not player.wiz.twistability
		and not (P_IsObjectOnGround(player.mo) and player.wiz.element != 1)
		and not P_PlayerInPain(player) and player.playerstate == PST_LIVE
		and not (player.mo.eflags & MFE_UNDERWATER)
		and not player.wiz.fistslam and not player.wiz.diving
			if player.wiz.jumpabilitytime == 0 and not player.wiz.jumpabilityloop
				player.wiz.jumpabilitytime = 35
			end
			
			if player.wiz.element == 0
				EarthPlatform(player)
			elseif player.wiz.element == 1
				BubbleJump(player)
			elseif player.wiz.element == 2
				CloudSurf(player)
			elseif player.wiz.element == 3
				FlameDash(player)
			end
		end
		
		player.wiz.jumpabilitytime = max($-1, 0)
		
		if player.wiz.jumpability and ((player.wiz.jumpabilitytime == 0
		and (player.wiz.element == 0 or player.wiz.element == 1 or player.wiz.element == 3
		or player.atap and player.wiz.jumpabilityloop) or ((P_IsObjectOnGround(player.mo)
		or (player.mo.eflags & MFE_SPRUNG)) and player.wiz.element != 1)
		or P_IsObjectInGoop(player.mo) or P_InQuicksand(player.mo))
		or P_PlayerInPain(player) or player.playerstate != PST_LIVE
		or (player.mo.eflags & MFE_UNDERWATER) or (player.wiz.jumpabilityblocked
		and (player.wiz.element == 2 or player.wiz.element == 3)))
			player.wiz.jumpability = false
			player.wiz.jumpabilitydelay = 50
			
			if player.wiz.jumpabilityloop
				player.wiz.jumpabilityloop = false
			end
			
			if player.wiz.jumpabilityblocked
				player.wiz.jumpabilityblocked = false
			end
			
			player.mo.flags = $&~MF_NOGRAVITY
			player.mo.flags = $&~MF_BOUNCE
			
			player.charflags = $&~SF_CANBUSTWALLS
			
			player.height = 48*FRACUNIT
			
			if player.wiz.bubble and player.wiz.bubble.valid
				P_KillMobj(player.wiz.bubble)
				S_StartSound(player.mo, sfx_s3k77)
			end
			
			if player.wiz.fireball and player.wiz.fireball.valid
				P_KillMobj(player.wiz.fireball)
				S_StartSound(player.mo, sfx_s1b3)
			end
			
			if player.playerstate == PST_LIVE and not P_PlayerInPain(player)
			and not P_IsObjectOnGround(player.mo) and not (player.mo.eflags & MFE_SPRUNG)
			and player.wiz.element != 0
				P_SetObjectMomZ(player.mo, FixedMul(5*FRACUNIT, player.mo.scale), true)
			end
		end
		
		player.wiz.jumpabilitydelay = max($-1, 0)
		
		if P_IsObjectOnGround(player.mo) and (player.pflags & PF_THOKKED)
			player.pflags = $&~PF_THOKKED
		end
		
		-- Crouch and Slide
		
		if player.mo.standingslope and P_IsObjectOnGround(player.mo)
			player.wiz.slidetime = min($+1, 100)
		elseif not P_IsObjectOnGround(player.mo)
			player.wiz.slidetime = 0
		else
			player.wiz.slidetime = max($-1, 0)
		end
		
		if (((player.btap and not player.wiz.crouching) or ((player.cmd.buttons & B) and player.wiz.crouching)
		or ((player.cmd.buttons & X) and player.wiz.diving) or (TwoD and player.cmd.forwardmove < -20 and not player.mo.currentaxis)
		or player.wiz.sliding) and player.playerstate == PST_LIVE and not P_PlayerInPain(player) and not player.wiz.banstate
		and P_IsObjectOnGround(player.mo) and not P_IsObjectInGoop(player.mo) and not P_IsObjectInFan(player.mo)
		and player.mo.state != S_PLAY_SKID) or player.wiz.forcecrouch or player.wiz.forceslide or player.wiz.sliping
			if not player.wiz.sliping
				player.height = 24*FRACUNIT
			end
			
			local SlideSpeed
			if not player.powers[pw_sneakers]
				if player.gotflag
					SlideSpeed = 25*FRACUNIT
				else
					SlideSpeed = 30*FRACUNIT
				end
			else
				if player.gotflag
					SlideSpeed = 45*FRACUNIT
				else
					SlideSpeed = 50*FRACUNIT
				end
			end
			
			if player.speed <= FixedMul(11*FRACUNIT, player.mo.scale)
				player.wiz.sliding = false
				player.wiz.crouching = true
				
				player.normalspeed = 5*FRACUNIT
				player.thrustfactor = 3
				player.jumpfactor = 3*FRACUNIT/2
				
				player.acceleration = 40
				player.pflags = $&~PF_SPINNING
				
				if player.xtap and not player.wiz.sliding
					P_InstaThrust(player.mo, player.drawangle, FixedMul(SlideSpeed, player.mo.scale))
					player.pflags = $|PF_SPINNING
					player.wiz.crouching = false
					player.wiz.sliding = true
				end
			elseif player.speed > FixedMul(11*FRACUNIT, player.mo.scale) or player.wiz.sliping
				player.wiz.crouching = false
				player.wiz.forcecrouch = false
				
				if not player.wiz.sliping and not player.wiz.diving
					player.wiz.sliding = true
				end
				
				if not (player.pflags & PF_SPINNING)
					P_InstaThrust(player.mo, player.drawangle, FixedMul(SlideSpeed, player.mo.scale))
					player.pflags = $|PF_SPINNING
				end
				
				if not player.wiz.slidetime and (not player.mo.standingslope or (player.mo.standingslope.flags & SL_NOPHYSICS))
					P_Thrust(player.mo, player.drawangle, FixedMul(-player.mo.friction/4 + FixedMul(abs(player.cmd.sidemove), player.acceleration), player.mo.scale))
				elseif player.mo.standingslope and not (player.mo.standingslope.flags & SL_NOPHYSICS)
					P_Thrust(player.mo, player.mo.standingslope.xydirection, player.mo.standingslope.zdelta * P_MobjFlip(player.mo) * 2)
				end
				
				player.acceleration = 500
				player.jumpfactor = 1*FRACUNIT
				
				P_SpawnSkidDust(player, player.mo.radius, true)
			end
		else
			player.wiz.crouching = false
			
			if player.wiz.sliding and not P_IsObjectOnGround(player.mo)
			and not (player.pflags & PF_JUMPED)
				player.wiz.sliding = false
			end
			
			if not (player.wiz.diving and not P_IsObjectOnGround(player.mo))
				player.height = 48*FRACUNIT
			end
			
			if not player.wiz.jumpability
				player.acceleration = 40
			end
			
			player.normalspeed = 15*FRACUNIT
			player.thrustfactor = 5
			player.jumpfactor = 1*FRACUNIT
			
			player.pflags = $&~PF_SPINNING
		end
		
		-- Ceiling Height Check
		
		if player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and player.mo.ceilingz - player.mo.floorz < FixedMul(48*FRACUNIT, player.mo.scale)
			if player.speed <= FixedMul(11*FRACUNIT, player.mo.scale)
				player.wiz.forcecrouch = true
			elseif player.speed > FixedMul(11*FRACUNIT, player.mo.scale)
				player.wiz.forceslide = true
			end
		else
			player.wiz.forcecrouch = false
			player.wiz.forceslide = false
		end
		
		-- Sliping
		
		if (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_ACECROUCH or player.mo.state == S_PLAY_ACESLIP)
		and (player.rmomx > FixedMul(11*FRACUNIT, player.mo.scale) or player.rmomy > FixedMul(11*FRACUNIT, player.mo.scale))
		and not player.wiz.sliding and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and P_IsObjectOnGround(player.mo) and not P_IsObjectInGoop(player.mo) and not P_InQuicksand(player.mo)
			player.wiz.sliping = true
		else
			player.wiz.sliping = false
		end
		
		-- Fist Slam
		
		if (player.btap and not player.wiz.fistslam) and not player.wiz.banstate
		and not player.wiz.jumpability and not player.wiz.twistability
		and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and not P_IsObjectOnGround(player.mo) and not P_IsObjectInGoop(player.mo)
		and not P_IsObjectInFan(player.mo) and not player.gotflag
			if player.wiz.diving
				player.wiz.diving = false
			end
			
			player.wiz.fistslam = true
			player.wiz.slamdelay = 15
			
			player.mo.momx = player.mo.momx/2
			player.mo.momy = player.mo.momy/2
			
			P_SetObjectMomZ(player.mo, FixedMul(5*FRACUNIT, player.mo.scale), true)
			S_StartSound(player.mo, sfx_ngjump)
		elseif player.wiz.fistslam and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and not player.wiz.banstate
			if not player.wiz.slamdelay
				if not P_IsObjectOnGround(player.mo) and not P_IsObjectInGoop(player.mo)
				and not (player.mo.eflags & MFE_SPRUNG) and not P_IsObjectInFan(player.mo)
					if (player.mo.momz > -30*FRACUNIT and not (player.mo.eflags & MFE_VERTICALFLIP))
					or (player.mo.momz < 30*FRACUNIT and (player.mo.eflags & MFE_VERTICALFLIP))
						P_SetObjectMomZ(player.mo, FixedMul(-30*FRACUNIT, player.mo.scale), true)
						S_StartSound(player.mo, sfx_mswing)
					end
				else
					if P_IsObjectOnGround(player.mo)
						player.wiz.slamtime = 5
						
						if (player.cmd.buttons & B)
							P_SetObjectMomZ(player.mo, FixedMul(10*FRACUNIT, player.mo.scale), true)
						else
							P_SetObjectMomZ(player.mo, FixedMul(5*FRACUNIT, player.mo.scale), true)
						end
						
						S_StartSound(player.mo, sfx_pstop)
					end
					
					player.wiz.fistslam = false
				end
			end
		end
		
		if player.wiz.fistslam and (P_IsObjectOnGround(player.mo)
		or P_IsObjectInGoop(player.mo) or P_InQuicksand(player.mo)
		or (player.mo.eflags & MFE_SPRUNG) or P_IsObjectInFan(player.mo))
			player.wiz.fistslam = false
			player.wiz.slamdelay = 0
		end
		
		player.wiz.slamdelay = max($-1, 0)
		player.wiz.slamtime = max($-1, 0)
		
		-- Sprint
		
		if (player.cmd.buttons & X) and P_IsObjectOnGround(player.mo)
		and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and not player.wiz.banstate and not player.wiz.crouching
		and not player.wiz.sliding and not player.wiz.sliping
		and not player.wiz.fistslam and not player.wiz.diving
			player.wiz.sprinting = true
			
			if player.gotflag
				player.normalspeed = 25*FRACUNIT
			else
				player.normalspeed = 30*FRACUNIT
			end
			
			player.thrustfactor = 10
		else
			player.wiz.sprinting = false
			
			if not player.wiz.crouching and not player.wiz.sliding
			and not player.wiz.sliping and not player.wiz.fistslam
			and not player.wiz.diving
				player.normalspeed = 15*FRACUNIT
				player.thrustfactor = 5
			end
		end
		
		-- Dive
		
		if player.xtap and not player.wiz.diving
		and not P_IsObjectOnGround(player.mo) and not P_IsObjectInGoop(player.mo)
		and not (player.mo.eflags & MFE_SPRUNG) and not P_IsObjectInFan(player.mo)
		and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and not player.wiz.banstate and not player.gotflag
		and not player.wiz.jumpability and not player.wiz.twistability
		and not player.wiz.crouching and not player.wiz.sliding
		and not player.wiz.sliping and not player.wiz.fistslam
			player.wiz.diving = true
			player.height = 24*FRACUNIT
			player.pflags = $|PF_DRILLING
			
			S_StartSound(player.mo, sfx_thok)
			
			local DiveSpeed
			if not player.powers[pw_sneakers]
				DiveSpeed = 30*FRACUNIT
			else
				DiveSpeed = 50*FRACUNIT
			end
			
			P_InstaThrust(player.mo, player.drawangle, FixedMul(DiveSpeed, player.mo.scale))
			P_SetObjectMomZ(player.mo, FixedMul(5*FRACUNIT, player.mo.scale), true)
		elseif ((not (player.cmd.buttons & X) and P_IsObjectOnGround(player.mo)) or P_IsObjectInGoop(player.mo)
		or ((player.mo.eflags & MFE_SPRUNG) and not player.wiz.slidetime) or P_IsObjectInFan(player.mo)
		or P_InQuicksand(player.mo)) or player.playerstate != PST_LIVE or P_PlayerInPain(player)
		or player.wiz.banstate or player.wiz.crouching or player.wiz.sliding or player.wiz.sliping
			player.wiz.diving = false
			player.pflags = $&~PF_DRILLING
			
			if not player.wiz.crouching and not player.wiz.sliding
				player.height = 48*FRACUNIT
			end
		end
		
		-- Switch Element
		
		if player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and not player.wiz.jumpability and not player.wiz.twistability
		and not (gametyperules & GTR_RINGSLINGER) and not srb2p
			if player.lbtap
				player.wiz.element = $-1
				S_StartSound(nil, sfx_tink)
			elseif player.rbtap
				player.wiz.element = $+1
				S_StartSound(nil, sfx_tink)
			end
		end
		
		if player.wiz.element < 0
			player.wiz.element = 3
		elseif player.wiz.element > 3
			player.wiz.element = 0
		end
		
		-- Cast
		
		if (player.cmd.buttons & RT) and player.playerstate == PST_LIVE
		and not P_PlayerInPain(player) and not player.wiz.banstate
		and not player.wiz.jumpability and not player.wiz.twistability
		and not player.wiz.sliding and not player.wiz.castrecharge
		and not player.wiz.shield and not (gametyperules & GTR_RINGSLINGER)
			if player.wiz.casttime > 0
				player.wiz.casting = true
				player.wiz.casttime = $-1
				player.wiz.castdelay = max($-1, 0)
				
				if player.wiz.element == 0 and player.wiz.castdelay == 0
					local Rock = P_SPMAngle(player.mo, MT_ACEEARTH, player.drawangle, 0)
					
					if Rock and Rock.valid
						Rock.tracer = player.mo
					end
					
					player.wiz.castdelay = 5
				elseif player.wiz.element == 1
					local Water = P_SPMAngle(player.mo, MT_ACEWATER, player.drawangle, 0)
					
					if Water and Water.valid
						Water.tracer = player.mo
					end
					
					if player.wiz.castdelay == 0
						player.wiz.castdelay = 5
						S_StartSound(player.mo, sfx_splish)
					end
				elseif player.wiz.element == 2
					local Wind = P_SPMAngle(player.mo, MT_ACEAIR, player.drawangle, 0)
					
					if Wind and Wind.valid
						Wind.tracer = player.mo
					end
					
					if player.wiz.castdelay == 0
						player.wiz.castdelay = 5
						S_StartSound(player.mo, sfx_s3kces)
					end
				elseif player.wiz.element == 3
					local Flame = P_SPMAngle(player.mo, MT_ACEFIRE, player.drawangle, 0)
					
					if Flame and Flame.valid
						Flame.tracer = player.mo
					end
					
					if player.wiz.castdelay == 0
						player.wiz.castdelay = 5
						S_StartSound(player.mo, sfx_fire)
					end
				end
			else
				player.wiz.castrecharge = true
			end
		else
			player.wiz.casting = false
			player.wiz.castdelay = 0
			player.wiz.casttime = min($+1, 100)
		end
		
		if player.rttap and player.wiz.castrecharge
			player.wiz.castrecharge = false
		end
		
		-- State Machine
		
		if player.wiz.jumpability and player.wiz.element == 0
			//if
				//player.mo.state = S_PLAY_ACEEARTHPLAT
			//else
				player.mo.state = S_PLAY_ACEEARTHPLAT_FAR
			//end
		elseif player.wiz.jumpability and player.wiz.element == 1
			player.mo.state = S_PLAY_ACEBUBBLEJUMP
		elseif player.wiz.jumpability and player.wiz.element == 2
			player.mo.state = S_PLAY_ACECLOUDSURF
		elseif player.wiz.jumpability and player.wiz.element == 3
			player.mo.state = S_PLAY_ACEFLAMEDASH
		elseif player.wiz.crouching
			if player.cmd.sidemove != 0 or not TwoD and not player.mo.currentaxis and player.cmd.forwardmove != 0
				player.mo.state = S_PLAY_ACECRAWL
			else
				player.mo.state = S_PLAY_ACECROUCH
			end
			
			if not srb2p
				player.powers[pw_strong] = STR_NONE
			end
		elseif player.wiz.fistslam or player.wiz.slamtime
			if not player.wiz.slamtime
				if player.wiz.slamdelay
				and player.mo.state != S_PLAY_ACESLAM_WIND
				and player.mo.state != S_PLAY_ACESLAM_WIND_2
					player.mo.state = S_PLAY_ACESLAM_WIND
				elseif not player.wiz.slamdelay
				and player.mo.state != S_PLAY_ACESLAM
				and player.mo.state != S_PLAY_ACESLAM_2
					player.mo.state = S_PLAY_ACESLAM
					
					if not srb2p
						player.powers[pw_strong] = STR_ANIM|STR_FLOOR|STR_SPRING|STR_HEAVY|STR_STOMP
					end
				end
			else
				if (player.cmd.buttons & B)
					player.mo.state = S_PLAY_ACESLAM_BOUNCE
				else
					player.mo.state = S_PLAY_ACESLAM_LAND
				end
				
				if not srb2p
					player.powers[pw_strong] = STR_NONE
				end
			end
		elseif player.wiz.diving
			player.mo.state = S_PLAY_ACEDIVE
			
			if not srb2p
				player.powers[pw_strong] = STR_ANIM|STR_PUNCH
			end
			
			if player.atap
				player.mo.state = S_PLAY_ACEDIVE_UNDIVE
				
				if not srb2p
					player.powers[pw_strong] = STR_NONE
				end
				
				player.wiz.diving = false
			end
		elseif player.wiz.sliding
			player.mo.state = S_PLAY_ACESLIDE
			
			if not srb2p
				player.powers[pw_strong] = STR_ANIM|STR_PUNCH
			end
			
			if player.atap
				player.mo.state = S_PLAY_ACESLIDE_JUMP
				
				if not srb2p
					player.powers[pw_strong] = STR_NONE
				end
				
				player.wiz.sliding = false
			end
		elseif player.wiz.sliping
			player.mo.state = S_PLAY_ACESLIP
			
			if not srb2p
				player.powers[pw_strong] = STR_NONE
			end
		else
			if not srb2p
				player.powers[pw_strong] = STR_NONE
			end
		end
		
		if player.mo.state == S_PLAY_ROLL
		or player.mo.state == S_PLAY_ACESLAM_BOUNCE
		or player.mo.state == S_PLAY_ACEDIVE_UNDIVE
		or player.mo.state == S_PLAY_ACESLIDE_JUMP
			player.wiz.banstate = true
		else
			player.wiz.banstate = false
		end
	end
end)

-- Wall Movement (WIP)

/*addHook("MobjLineCollide", function(mo, line) 
	if (line.frontsector and line.frontsector.ceilingpic == "F_SKY1"
	and mo.z > line.frontsector.ceilingheight) or (line.backsector
	and line.backsector.ceilingpic == "F_SKY1" and mo.z > line.backsector.ceilingheight)
	return end
	
	if not mo.wall
		mo.wall = line
	else
		mo.wall = nil
	end
	
	return nil
end, MT_PLAYER)

addHook("MobjMoveBlocked", function(mo)
	if mo and mo.valid and mo.player and mo.player.valid and mo.skin == "ace"
		if (mo.player.wiz.jumpability or ((mo.player.cmd.buttons & A)
		and not P_IsObjectOnGround(mo) and mo.player.playerstate == PST_LIVE
		and not P_PlayerInPain(mo.player) and mo.state != S_PLAY_ROLL
		and not mo.player.wiz.jumpability and not mo.player.wiz.twistability))
		and mo.wall
			if mo.player.wiz.jumpability
				mo.player.wiz.jumpabilityblocked = true
			else
				mo.player.wiz.wallslide = true
				
				mo.player.drawangle = R_PointToAngle2(mo.x, mo.y, P_ClosestPointOnLine(mo.x, mo.y, mo.wall))// + ANGLE_90
				mo.momz = $/2
			end
		elseif not (mo.player.cmd.buttons & A) and mo.player.wiz.wallslide
			mo.player.wiz.wallslide = false
			
			P_InstaThrust(mo, -mo.player.drawangle, FixedMul(15*FRACUNIT, mo.scale))
			P_SetObjectMomZ(mo, FixedMul(15*FRACUNIT, mo.scale))
		end
	end
end, MT_PLAYER)*/

-- Spring Check

local function SpringCheck(mo, spring)
	if not (spring and spring.valid)
	or not (mo and mo.valid)
		return
	end
	
	if (spring.flags & MF_SPRING)
	and mo.z <= spring.z + spring.height
	and mo.z + mo.height >= spring.z
		if P_IsObjectOnGround(mo) and mobjinfo[spring.type].damage
			mo.player.wiz.slidetime = mobjinfo[spring.type].damage
		end
	end
end

addHook("MobjCollide", SpringCheck, MT_PLAYER)
addHook("MobjMoveCollide", SpringCheck, MT_PLAYER)

-- Player Attacks

addHook("PlayerCanDamage", function(player)
	if player.mo.valid and player.mo.skin == "ace"
		if (player.wiz.jumpability and player.wiz.element == 3)
		or player.wiz.sliding or (player.wiz.fistslam or player.wiz.slamtime)
		or player.wiz.diving
			return true
		end
		
		if player.wiz.sliping
			return false
		end
	end
end)

-- Player Protection

addHook("ShouldDamage", function (target, inflictor, source, damage, damagetype)
	if target.player and target.player.valid and target.skin == "ace"
	and not (damagetype & DMG_DEATHMASK)
		if target.player.wiz.shield and not (damagetype and damagetype == DMG_NUKE)
		and target.player.wiz.shieldorb and target.player.wiz.shieldorb.valid
			return false
		end
		
		if target.player.wiz.jumpability and target.player.wiz.element == 1
		and damagetype and damagetype == DMG_WATER
			return false
		end
		
		if target.player.wiz.jumpability and target.player.wiz.element == 3
		and damagetype and damagetype == DMG_FIRE
			return false
		end
	end
end, MT_PLAYER)

-- Player Damage (WIP)

/*addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if target.player and target.player.valid and target.skin == "ace"
		if target.player.wiz.shield
		and target.player.wiz.shieldorb and target.player.wiz.shieldorb.valid
		and damagetype == DMG_NUKE//not target.player.wiz.parry and damagetype == DMG_NUKE
			P_PlayerInPain(target.player)
			//P_PlayDeathSound(target)
		end
	end
end, MT_PLAYER)*/

-- Casted Elements

addHook("MobjThinker", function(mobj)
	if mobj and mobj.valid and mobj.tracer
	and mobj.tracer.player and mobj.tracer.player.valid
		if mobj.type == MT_ACEEARTH or mobj.type == MT_ACEBOULDER
			//if 
				
			//end
		elseif mobj.type == MT_ACEWATER
			//if 
				
			//end
		elseif mobj.type == MT_ACEAIR
			//if 
				
			//end
		elseif mobj.type == MT_ACEFIRE
			//if 
				
			//end
		end
		
		mobj.info.speed = 30*FRACUNIT + mobj.tracer.player.speed
	end
end)

local function ElementsCollide(mobj, target) -- Sounds like that movie...
	if not target or not target.valid or not mobj or not mobj.valid
	or not (mobj.z <= target.z + target.height and target.z <= mobj.z + mobj.height)
	or (mobj.type != MT_ACEEARTH and mobj.type != MT_ACEBOULDER and mobj.type != MT_ACEWATER
	and mobj.type != MT_ACEAIR and mobj.type != MT_ACEFIRE) return end
	if not mobj.tracer or not mobj.tracer.valid or mobj.tracer == target return false end
	
	if target and target.valid
		if (target.type == MT_SPIKE or target.type == MT_WALLSPIKE
		or target.type == MT_SALOONDOOR or target.type == MT_SALOONDOORCENTER) -- Here's another character that can do the ACZ2 Minecart skip.
		and (mobj.type == MT_ACEEARTH or mobj.type == MT_ACEBOULDER)
			if target.type == MT_SALOONDOOR
				P_SpawnMobjFromMobj(target, 0, 0, target.height, MT_WOODDEBRIS)
				P_SpawnMobjFromMobj(target, 0, 0, target.height - mobj.height, MT_WOODDEBRIS)
				P_SpawnMobjFromMobj(target, 0, 0, target.height/2 + mobj.height, MT_WOODDEBRIS)
				P_SpawnMobjFromMobj(target, 0, 0, target.height/2 - mobj.height, MT_WOODDEBRIS)
				
				S_StartSound(mo, sfx_wbreak)
			end
			
			P_KillMobj(target, mobj)
		end
	end
	
	if target and target.valid
		if (target.flags & MF_FIRE) and (mobj.type == MT_ACEWATER or mobj.type == MT_ACEAIR)
			if target.target
				if target.target.burning
					target.target.burning = false
				end
			end
			
			local Smoke = P_SpawnMobj(target.x, target.y, target.z + target.height/4, MT_SMOKE)
			Smoke.scale = target.radius/8
			
			S_StartSound(target, sfx_steam1)
			P_KillMobj(target, mobj)
		end
	end
	
	if target and target.valid
		if mobj.type == MT_ACEAIR and ((target.flags & MF_PUSHABLE)
		or (target.flags & MF_ENEMY) or (target.flags & MF_BOSS))
			P_InstaThrust(target, mobj.angle, (mobjinfo[mobj.type].speed/2)-mobjinfo[target.type].speed)
		end
	end
	
	if target and target.valid
		if not target.player and not target.burning
		and not (target.flags & MF_FIRE) and ((target.flags & MF_SCENERY)
		or (target.flags & MF_ENEMY) or target.type == MT_FLAMEHOLDER
		or target.type == MT_TORCHFLOWER) and mobj.type == MT_ACEFIRE
			local Height
			if target.type == MT_FLAMEHOLDER or target.type == MT_TORCHFLOWER
				Height = target.height
			else
				Height = target.height/4
			end
			
			local Flame = P_SpawnMobj(target.x, target.y, target.z + Height, MT_FLAME)
			Flame.flags = MF_NOGRAVITY|MF_FIRE
			Flame.target = target
			
			if target.type != MT_FLAMEHOLDER and target.type != MT_TORCHFLOWER
				Flame.fuse = TICRATE*2
			end
			
			S_StartSound(target, sfx_s1b3)
			target.burning = true
		end
		
		if (target.flags & MF_FIRE) and mobj.type == MT_ACEFIRE
			mobj.flags = $&~MF_MISSILE
		end
	end
end

addHook("MobjCollide", ElementsCollide)
addHook("MobjMoveCollide", ElementsCollide)

addHook("MobjThinker", function(flame)
	if not flame or not flame.valid return end
	if not flame.target or not flame.target.valid return end
	
	local Height
	if flame.target.type == MT_FLAMEHOLDER or flame.target.type == MT_TORCHFLOWER
		Height = flame.target.height
		
		flame.scale = flame.target.scale
		flame.target.burning = true
	else
		Height = flame.target.height/4
		flame.scale = flame.target.radius/8
		
		P_DamageMobj(flame.target, flame, flame, DMG_FIRE)
	end
	
	P_MoveOrigin(flame,
	flame.target.x + flame.target.momx,
	flame.target.y + flame.target.momy,
	flame.target.z + Height + flame.target.momz)
	
	if not flame.target.health
		P_KillMobj(flame)
	end
end, MT_FLAME)

addHook("MobjFuse", function(flame)
	flame.target.burning = false
end, MT_FLAME)